/*******************************************************************************
 * 
 *  Struts2-Conversation-Plugin - An Open Source Conversation- and Flow-Scope Solution for Struts2-based Applications
 *  =================================================================================================================
 * 
 *  Copyright (C) 2012 by Rees Byars
 *  http://code.google.com/p/struts2-conversation/
 * 
 * **********************************************************************************************************************
 * 
 *  Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 *  the License. You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 *  Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 *  an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 *  specific language governing permissions and limitations under the License.
 * 
 * **********************************************************************************************************************
 * 
 *  $Id: ConversationFormTag.java reesbyars $
 ******************************************************************************/
package com.google.code.rees.scope.struts2.ui;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts2.components.Component;
import org.apache.struts2.views.jsp.ui.FormTag;

import com.opensymphony.xwork2.util.ValueStack;

/**
 * A normal {@link FormTag} using {@link ConversationForm} instead
 * of {@link org.apache.struts2.components.Form Form}
 * 
 * @author rees.byars
 */
public class ConversationFormTag extends FormTag {

    private static final long serialVersionUID = -7730872356094866344L;

    public Component getBean(ValueStack stack, HttpServletRequest req,
            HttpServletResponse res) {
        return new ConversationForm(stack, req, res);
    }

}
